#include <stdio.h>
#include <string.h>
#include "aes.h"

void phex16(char* str)
{
	int i;
	for (i = 0; i < 16; ++i)
		printf("%.2x", ((int)(str[i])&255));
	printf("\n");
}

void keyrecover(char* plaintext, char* target, char* key)
{
  int b,i,c;
  char ciphertext[16];
  
  c=0;
  memset(key, 0, 16);
  while (1)
  {
    // loop over last byte
    for (b = 0; b < 256; ++b)
    {
      // set last byte
      key[15] = b;
      // ciphertext = AES(plaintext,key);
      AES128_ECB_encrypt(plaintext, key, ciphertext);
      // check if ciphertext == target
      i=0;
      for (; i < 16; ++i)
        if (ciphertext[i]!=target[i])
          break;
      // return if ciphertext == target
      if (i==16)
        return;
    }
    ++c;
    if ((c & 0xFFFF)==0)
      printf(".");
    // one step for other 15 bytes
    i=14;
    while (i >= 0 && (++key[i])==0)
      --i;
    // exhausted key space
    if (i < 0)
      return;
  }
}

int main(int argc, char** argv)
{
  char key[16];
  char plaintext[16] = "plaintext";
  char ciphertext[16];
  // target: 
  // BASE64: fgpIqNL2jNOcnbGyeBH3wQ==
  // HEX:     0x7e 0x0a 0x48 0xa8 0xd2 0xf6 0x8c 0xd3 0x9c 0x9d 0xb1 0xb2 0x78 0x11 0xf7 0xc1
  // convert target from base64 to hex using http://tomeko.net/online_tools/base64.php?lang=en
  char target[16] = {  0x7e, 0x0a, 0x48, 0xa8, 0xd2, 0xf6, 0x8c, 0xd3, 0x9c, 0x9d, 0xb1, 0xb2, 0x78, 0x11, 0xf7, 0xc1 };
  int plaintextlen, paddinglen,i;

  memset(key, 0, 16);
  key[15]=0xff;
  
  plaintextlen = strlen(plaintext);
  paddinglen = 16-plaintextlen;
  for (i = 16-paddinglen; i < 16; ++i)
    plaintext[i]=(char)(paddinglen);
  
  printf("plaintext:  ");
  phex16(plaintext);

  printf("target:     ");
  phex16(target);

  keyrecover(plaintext, target, key);

  printf("\nkey:        ");
  phex16(key);
  
  return 0;
}
